#ifndef __button_h__
#define __button_h__

#include <MLV/MLV_all.h>
#include "rectangle.h"
#include <string>

class Button {
	public:
		Rectangle rect;
		std::string text;
		Button(){
			this->text = "";
			initRectangle( &rect, 0, 0, 0, 0);
		}
		void init( int x, int y, int width, int height, const std::string& text ){
			this->text = text;
			initRectangle( &rect, x, y, width, height);
		}
		Button( int x, int y, int width, int height, const std::string& text ){
			this->init( x, y, width, height, text );
		}
		bool isInside( int x, int y){
			return isInRectangle(&this->rect, x,y);
		}
		void draw(
			int interligne,
			MLV_Color border, MLV_Color text, MLV_Color background
		){
			MLV_draw_text_box (
				rect.x,
				rect.y,
				rect.width,
				rect.height,	
				this->text.c_str(), interligne, 
				border, text, background,
				MLV_TEXT_LEFT, MLV_HORIZONTAL_CENTER, MLV_VERTICAL_CENTER
			);
		}
};

#endif

