#ifndef __dyck_code_h__
#define __dyck_code_h__

#include <boost/graph/adjacency_list.hpp>

typedef boost::adjacency_list<
	boost::setS,
	boost::vecS,
	boost::undirectedS
> UndirectedGraph;

typedef struct {
	int n;
	int* code;
} Dyck_word;

void free_dyck_word( Dyck_word* dyck_word );

Dyck_word* first_dyck_word( int n );
Dyck_word* next_dyck_word( Dyck_word* dyck_word );

void print_dyck_code_pretty( Dyck_word* dyck_word, char up, char down );
void print_dyck_code( Dyck_word* dyck_word );

UndirectedGraph dyck_word_to_bipartite_graph( Dyck_word* dyck_word );
UndirectedGraph dyck_word_to_graph( Dyck_word* dyck_word );

#endif
