#include <MLV/MLV_all.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "geometrie.h"
#include "debug.h"


Point_i* get_points( int n ){
	int i=0;
	Point_i* res = (Point_i* ) malloc( n * sizeof( Point_i ) );
	for( i =0; i<n ; i++){
		int x,y,state;
//		MLV_wait_mouse( &x, &y );
		MLV_Event event=MLV_NONE;
		state = MLV_NONE;
		MLV_save_screen();
		while(
			( event = MLV_get_event( 
				NULL, NULL, NULL,
				NULL, NULL,
				&x, &y, NULL,
				&state
			) ) != MLV_MOUSE_BUTTON
			|| state != MLV_PRESSED
		){
			if( event == MLV_MOUSE_MOTION ){
				char message[100];
				snprintf( message, 100, "x : %d, y : %d",x,y);
				MLV_load_screen();
				MLV_draw_adapted_text_box (
					0, 0, message, 9,
					MLV_COLOR_RED, MLV_COLOR_GREEN, MLV_COLOR_BLACK,
					MLV_TEXT_LEFT, NULL, NULL 
				);
				MLV_actualise_window();
			}
		}

		MLV_load_screen();
		MLV_draw_circle( x,y, 2, MLV_COLOR_RED );
		MLV_actualise_window();
		res[i].x = x;
		res[i].y = y;
	}
	return res;
}


//Point_i* get_points( int n ){
//	int i=0;
//	Point_i* res = (Point_i* ) malloc( n * sizeof( Point_i ) );
//	for( i =0; i<n ; i++){
//		int x,y;
//		MLV_wait_mouse( &x, &y );
//		MLV_draw_circle( x,y, 2, MLV_COLOR_RED );
//		MLV_actualise_window();
//		res[i].x = x;
//		res[i].y = y;
//	}
//	return res;
//}

void draw_point( int x, int y, int rayon, MLV_Color color ){
	MLV_draw_circle( x, y, rayon, color );
	MLV_draw_point( x, y, color );
}

void draw_point_struct( const Point_i* p, int rayon, MLV_Color color ){
	draw_point( p->x, p->y, rayon, color );
}

void draw_points( Point_i* points, int n, int rayon, MLV_Color color ){
	int i;
	for( i=0; i<n; i++ ){
		draw_point_struct( points+i, rayon, color );
	}
}

int main( int argc, char *argv[] ){
	int width = 640, height = 480;
	MLV_create_window("", "", width, height);

	MLV_draw_filled_rectangle( 0,0,width,height, MLV_COLOR_GREY );
	MLV_actualise_window();

while(true){
	
	int n = 2;
	Point_i* points_i = get_points( n );
	Point_f* points_f = (Point_f* ) malloc( n * sizeof( Point_f ) );
	array_of_couple_i_to_f( points_i, points_f, n );

	int rayon = 3;
	draw_points( points_i, n, rayon, MLV_COLOR_RED );

	MLV_draw_line(
		points_i[0].x, points_i[0].y,
		points_i[1].x, points_i[1].y,
		MLV_COLOR_BLUE
	);

	Point_f fermat_f;
	Point_i fermat_i;
	center_of_fermat_circle( points_f, points_f+1, &fermat_f );
	couple_f_to_i( &fermat_f, &fermat_i );
	draw_point_struct( &fermat_i, 3, MLV_COLOR_GREEN );

	Fermat_locus_iterator it;


	int pas = 20;
	init_femat_locus_iterator( points_i, points_i+1, &it,pas );
	do{
		get_point_from_fermat_locus_iterator( &it, &fermat_i);
		draw_point( fermat_i.x, fermat_i.y, 3, MLV_COLOR_RED );
		Point_f direction1 = {
			(float) (fermat_i.x - points_i[0].x),
			(float) (fermat_i.y - points_i[0].y)
		};
		Point_f direction2 = {
			(float) (fermat_i.x - points_i[1].x),
			(float) (fermat_i.y - points_i[1].y)
		};
		float a = angle( &direction2, &direction1 );
//		printf("Angle: %f\n", a);
		MLV_actualise_window();
		MLV_wait_mouse(NULL,NULL);
	}while( next_fermat_locus_iterator( &it ) );


	MLV_actualise_window();


	MLV_wait_mouse(NULL,NULL);

	free( points_i );
	free( points_f );

}

	MLV_close_window();
	return 0;
}

