#include <MLV/MLV_all.h>
#include <stdio.h>
#include <stdlib.h>

#include "geometrie.h"

Point_i* get_points( int n ){
	int i=0;
	Point_i* res = (Point_i* ) malloc( n * sizeof( Point_i ) );
	for( i =0; i<n ; i++){
		int x,y;
		MLV_wait_mouse( &x, &y );
		MLV_draw_circle( x,y, 2, MLV_COLOR_RED );
		MLV_actualise_window();
		res[i].x = x;
		res[i].y = y;
	}
	return res;
}

void draw_point( int x, int y, int rayon, MLV_Color color ){
	MLV_draw_circle( x, y, rayon, color );
	MLV_draw_point( x, y, color );
}

void draw_point_struct( const Point_i* p, int rayon, MLV_Color color ){
	draw_point( p->x, p->y, rayon, color );
}

void draw_points( Point_i* points, int n, int rayon, MLV_Color color ){
	int i;
	for( i=0; i<n; i++ ){
		draw_point_struct( points+i, rayon, color );
	}
}

int main( int argc, char *argv[] ){
	int width = 640, height = 480;
	MLV_create_window("", "", width, height);
	
	int n = 4;
	Point_i* points_i = get_points( n );
	Point_f* points_f = (Point_f* ) malloc( n * sizeof( Point_f ) );
	array_of_couple_i_to_f( points_i, points_f, n );

	int rayon = 3;
	draw_points( points_i, n, rayon, MLV_COLOR_RED );

	MLV_draw_line(
		points_i[0].x, points_i[0].y,
		points_i[1].x, points_i[1].y,
		MLV_COLOR_BLUE
	);
	MLV_draw_line(
		points_i[2].x, points_i[2].y,
		points_i[3].x, points_i[3].y,
		MLV_COLOR_BLUE
	);

	Point_f intersection_f;
	Point_i intersection_i;
	if(
		intersection_point_and_point(
			points_f, points_f+1,
			points_f+2, points_f+3,
			&intersection_f
		)
	){
		couple_f_to_i( &intersection_f, &intersection_i );
		draw_point_struct( &intersection_i, 3, MLV_COLOR_GREEN );
	}
	
	MLV_actualise_window();

	MLV_wait_mouse(NULL,NULL);	

	free( points_i );
	free( points_f );

	MLV_close_window();
	return 0;
}

